# encoding: utf-8

require 'open-uri'
require 'json'
require 'timeout'

module RunningTrack
	module Data
		
		class RunningTrackNoDataError < Exception
		end

		REQUEST_TIMEOUT = 100
		DATA_URL = "http://api.data.mos.ru/v1/datasets/899/rows"

		def self.import
			Timeout::timeout(REQUEST_TIMEOUT) do
				# sleep 5
				data = open(DATA_URL).read
				# data = ""
				raise RunningTrackNoDataError, "Нет данных" if data.length == 0
				JSON.parse data
			end
		end
		
	end
end