# encoding: utf-8

require 'terminal-table'
require 'active_support/all'

require_relative 'track_collection'

module RunningTrack
	class Table

		COLUMNS = ["District", "Address", "HelpPhone", "ObjectHasWifi"]

		def print
			puts create_table
		end

		def initialize data
			if data
				rows = slice_rows data
				@track_collection = TrackCollection.new rows
			else
				@track_collection = TrackCollection.new
				@track_collection.load!
			end
		end

		private

		def create_table
			rows = @track_collection.tracks.map do |e|  
				e.to_hash.values
			end
			sep_rows = rows.zip(Array.new(rows.count - 1) { :separator }).flatten(1).compact
			Terminal::Table.new rows: sep_rows, headings: COLUMNS
		end

		def slice_rows rows
			rows.map! do |row| 
				row["Cells"].slice(*COLUMNS)
			end
		end

  end
end

# 

# SPLITTER = ';'

# attr_reader :rows

# def initialize data
#   puts "[RunningTrack::Table]: Create running track table"
#   @rows = prepare data
# end

# def print
#   @table ||= create_table
# #   puts @table
# end


# # private

# def prepare data
#   data.map{ |line| line.split(SPLITTER) }
# end

# def create_table
#   puts "[RunningTrack::Table]: Create terminal table"
#   headings = @rows.shift
#   sep_rows = @rows.zip(Array.new(@rows.count - 1){ :separator }).flatten(1).compact
#   Terminal::Table.new headings: headings, rows: sep_rows
# end