require 'workflow'

module RunningTrack
	class Track

		include Workflow

		TRACK_DISTRICT_KEY = :district
		TRACK_ADDRESS_KEY  = :address
		TRACK_PHONE_KEY    = :helpPhone
		TRACK_HAS_WIFI_KEY = :objectHasWifi

		def initialize track_data
			@district      = track_data[TRACK_DISTRICT_KEY]
			@address       = track_data[TRACK_ADDRESS_KEY]
			@helpPhone     = track_data[TRACK_PHONE_KEY]
			@objectHasWifi = track_data[TRACK_HAS_WIFI_KEY]
		end

		def to_hash
			{ 
				TRACK_DISTRICT_KEY => @district,
				TRACK_ADDRESS_KEY  => @address,
				TRACK_PHONE_KEY    => @helpPhone,
				TRACK_HAS_WIFI_KEY => @objectHasWifi
			}
		end

		workflow do
	    state :new do
	      event :good_state, transitions_to: :good
	      event :normal_state, transitions_to: :normal
	      event :bad_state, transitions_to: :bad
	    end

	    state :good do
	      event :normal_state, transitions_to: :normal
	      event :bad_state, transitions_to: :bad
	    end

	    state :normal do
	      event :bad_state, transitions_to: :bad
	      event :good_state, transitions_to: :good
	    end

	    state :bad do
	    	event :normal_state, transitions_to: :normal
	    	event :good_state, transitions_to: :good
	    end
  	end

		def to_s
			"District: #{@district}, address: #{@address}, phone: #{@helpPhone}, has Wi-Fi: #{@objectHasWifi}"
		end
	end
end