
require 'yaml'
require_relative 'track'

module RunningTrack
	class TrackCollection

		attr_reader :tracks

		class RunningTrackLoadLocalDataError < Exception
		end

		def initialize data = Array.new
			@tracks = data.map do |e|
				Track.new({
					Track::TRACK_DISTRICT_KEY => e["District"],
					Track::TRACK_ADDRESS_KEY => e["Address"],
					Track::TRACK_PHONE_KEY => e["HelpPhone"],
					Track::TRACK_HAS_WIFI_KEY => e["ObjectHasWifi"]
				})
			end
			# p find(Track::TRACK_HAS_WIFI_KEY, "нет")
			@tracks = random(@tracks.count)
		end

		def random count = 1
			@tracks.shuffle.slice(0..count-1)
		end

		def find key, value
			@tracks.select do |e|
				e.to_hash[key] == value
			end
		end

		def save!
			File.open('./data/file.yml', 'w') {|f| f.write self.to_hash.to_yaml }
		end

		def load!
			local_data = YAML.load_file('./data/file.yml')
			raise RunningTrackLoadLocalDataError, "Локальных данных нет!" if !local_data
			@tracks = YAML.load_file('./data/file.yml').map do |e| 
				Track.new(e)
			end
		end

		def to_hash
			hash = @tracks.map do |e|   
				e.to_hash
			end
		end

	end
end